#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <syslog.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/************* Configure the following to suit your account ****************/

/* Putting your domain name is optional, I guess */
#define EHLO_DOMAIN "EHLO my.client.domain\r\n"
#define SERVER_ACCOUNT "0001234567"
/* Your account password is used as the MD5 secret. It is not sent in clear. */
#define SECRET "password"

/************** The following should be ok for mailkeep ********************/

/* 212.69.230.21 is currently secure.mailkeep.com */
#define SERVER_ADDR "212.69.230.21"
/* port 366 is ODMR On-Demand Mail Relay */
#define SERVER_PORT 366 
/* Check for mail every 10 mins. */
#define SLEEP_TIME 600

#define MTA "/usr/sbin/exim"
#define MTA_PARAM "-bs"

/***************************************************************************/

#define MAX_STR 255
#define TIMEOUT 120

typedef struct md5 {
  unsigned int length;
  unsigned int abcd[4];
  }
md5;
//#define uschar unsigned char
typedef unsigned char uschar;

//extern int debug;
#define debug 0
extern char buff[MAX_STR];

void trap_hup(int signum);
int receivestr(int fd, char *str);
int sendstr(int fd, char *str);
int readline(int fd, char* ptr,int maxlen);
int writen(int fd,char *ptr, int nbytes);
int get_response(int fd);
int send_cmd(int fd, char * cmd);
void md5_start(md5 *base);
void md5_mid(md5 *base, const unsigned char *text);
void md5_end(md5 *base, const unsigned char *text, int length, unsigned char *digest);
int auth_b64decode(char *code, char *result);
void auth_b64encode(char *clear, int len,char *code);
void compute_cram_md5(char *secret, char *challenge,unsigned char *digestptr);
void spawn_mail_handler(int serverfd);
void daemon_init(void);
